//
// PointsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PointsAPI {
    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeHeightHeightQuarterhoursGet: String { 
        case timestampinit = "timestampInit"
        case temp = "temp"
        case wetbulb = "wetBulb"
        case dewpt = "dewPt"
        case feelslike = "feelsLike"
        case windchill = "windChill"
        case heatindex = "heatIndex"
        case relhum = "relHum"
        case spchum = "spcHum"
        case pres = "pres"
        case mslpres = "mslPres"
        case windspd = "windSpd"
        case winddir = "windDir"
        case precip = "precip"
        case snowfall = "snowfall"
        case snowfallkuchera = "snowfallKuchera"
        case cldcvr = "cldCvr"
        case radsolar = "radSolar"
        case radsolardirect = "radSolarDirect"
        case cin = "cin"
        case cape = "cape"
        case hailsize = "hailSize"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete vertically interpolated quarterhourly HRRR forecast for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter height: (path) The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, snowfall, snowfallKuchera, hailSize)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeHeightHeightQuarterhoursGet(latitude: Float, longitude: Float, height: Decimal, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursGet? = nil, completion: @escaping ((_ data: HrrrForecastPointHourObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeHeightHeightQuarterhoursGetWithRequestBuilder(latitude: latitude, longitude: longitude, height: height, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete vertically interpolated quarterhourly HRRR forecast for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/height/{height}/quarterhours

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "radSolar" : 0,
    "hailSize" : 0.2,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "pres" : 1013.83,
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "cin" : -100.1,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "windDir" : 302.6,
    "wetBulb" : 46.32,
    "relHum" : 96.87,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "snowfallKuchera" : 1.2,
    "radSolarDirect" : 0,
    "cape" : 2012.42,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "radSolar" : 0,
    "hailSize" : 0.2,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "pres" : 1013.83,
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "cin" : -100.1,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "windDir" : 302.6,
    "wetBulb" : 46.32,
    "relHum" : 96.87,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "snowfallKuchera" : 1.2,
    "radSolarDirect" : 0,
    "cape" : 2012.42,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "temp" : "Fahrenheit",
      "wetBulb" : "Fahrenheit",
      "dewPt" : "Fahrenheit",
      "feelsLike" : "Fahrenheit",
      "windChill" : "Fahrenheit",
      "heatIndex" : "Fahrenheit",
      "relHum" : "Percent value in [0,100]",
      "spcHum" : "Grams of Moisture per Kilograms of Air",
      "pres" : "Millibars",
      "mslPres" : "Millibars",
      "windSpd" : "Miles per Hour",
      "windDir" : "Degrees [0,360] (0 = North)",
      "precip" : "Inches",
      "snowfall" : "Inches",
      "snowfallKuchera" : "Inches",
      "cldCvr" : "Percent value in [0,100]",
      "radSolar" : "Watts per Square Meter",
      "radSolarDirect" : "Watts per Square Meter",
      "cin" : "Joules per kilogram",
      "cape" : "Joules per kilogram",
      "hailSize" : "Meters"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter height: (path) The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, snowfall, snowfallKuchera, hailSize)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<HrrrForecastPointHourObj> 
     */
    open class func pointsLatitudelongitudeHeightHeightQuarterhoursGetWithRequestBuilder(latitude: Float, longitude: Float, height: Decimal, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursGet? = nil) -> RequestBuilder<HrrrForecastPointHourObj> {
        var path = "/points/{latitude},{longitude}/height/{height}/quarterhours"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let heightPreEscape = "\(height)"
        let heightPostEscape = heightPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{height}", with: heightPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<HrrrForecastPointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeHeightHeightQuarterhoursTimestampGet: String { 
        case timestampinit = "timestampInit"
        case temp = "temp"
        case wetbulb = "wetBulb"
        case dewpt = "dewPt"
        case feelslike = "feelsLike"
        case windchill = "windChill"
        case heatindex = "heatIndex"
        case relhum = "relHum"
        case spchum = "spcHum"
        case pres = "pres"
        case mslpres = "mslPres"
        case windspd = "windSpd"
        case winddir = "windDir"
        case precip = "precip"
        case snowfall = "snowfall"
        case snowfallkuchera = "snowfallKuchera"
        case cldcvr = "cldCvr"
        case radsolar = "radSolar"
        case radsolardirect = "radSolarDirect"
        case cin = "cin"
        case cape = "cape"
        case hailsize = "hailSize"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursTimestampGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A quarterhour of vertically interpolated HRRR forecast data for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter height: (path) The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, snowfall, snowfallKuchera, hailSize)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeHeightHeightQuarterhoursTimestampGet(latitude: Float, longitude: Float, timestamp: Date, height: Decimal, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursTimestampGet? = nil, completion: @escaping ((_ data: HrrrForecastPointHourObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeHeightHeightQuarterhoursTimestampGetWithRequestBuilder(latitude: latitude, longitude: longitude, timestamp: timestamp, height: height, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A quarterhour of vertically interpolated HRRR forecast data for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/height/{height}/quarterhours/{timestamp}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "radSolar" : 0,
    "hailSize" : 0.2,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "pres" : 1013.83,
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "cin" : -100.1,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "windDir" : 302.6,
    "wetBulb" : 46.32,
    "relHum" : 96.87,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "snowfallKuchera" : 1.2,
    "radSolarDirect" : 0,
    "cape" : 2012.42,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "radSolar" : 0,
    "hailSize" : 0.2,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "pres" : 1013.83,
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "cin" : -100.1,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "windDir" : 302.6,
    "wetBulb" : 46.32,
    "relHum" : 96.87,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "snowfallKuchera" : 1.2,
    "radSolarDirect" : 0,
    "cape" : 2012.42,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "temp" : "Fahrenheit",
      "wetBulb" : "Fahrenheit",
      "dewPt" : "Fahrenheit",
      "feelsLike" : "Fahrenheit",
      "windChill" : "Fahrenheit",
      "heatIndex" : "Fahrenheit",
      "relHum" : "Percent value in [0,100]",
      "spcHum" : "Grams of Moisture per Kilograms of Air",
      "pres" : "Millibars",
      "mslPres" : "Millibars",
      "windSpd" : "Miles per Hour",
      "windDir" : "Degrees [0,360] (0 = North)",
      "precip" : "Inches",
      "snowfall" : "Inches",
      "snowfallKuchera" : "Inches",
      "cldCvr" : "Percent value in [0,100]",
      "radSolar" : "Watts per Square Meter",
      "radSolarDirect" : "Watts per Square Meter",
      "cin" : "Joules per kilogram",
      "cape" : "Joules per kilogram",
      "hailSize" : "Meters"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter height: (path) The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, snowfall, snowfallKuchera, hailSize)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<HrrrForecastPointHourObj> 
     */
    open class func pointsLatitudelongitudeHeightHeightQuarterhoursTimestampGetWithRequestBuilder(latitude: Float, longitude: Float, timestamp: Date, height: Decimal, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursTimestampGet? = nil) -> RequestBuilder<HrrrForecastPointHourObj> {
        var path = "/points/{latitude},{longitude}/height/{height}/quarterhours/{timestamp}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let timestampPreEscape = "\(timestamp)"
        let timestampPostEscape = timestampPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestamp}", with: timestampPostEscape, options: .literal, range: nil)
        let heightPreEscape = "\(height)"
        let heightPostEscape = heightPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{height}", with: heightPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<HrrrForecastPointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeHeightHeightQuarterhoursTimestampStarttimestampEndGet: String { 
        case timestampinit = "timestampInit"
        case temp = "temp"
        case wetbulb = "wetBulb"
        case dewpt = "dewPt"
        case feelslike = "feelsLike"
        case windchill = "windChill"
        case heatindex = "heatIndex"
        case relhum = "relHum"
        case spchum = "spcHum"
        case pres = "pres"
        case mslpres = "mslPres"
        case windspd = "windSpd"
        case winddir = "windDir"
        case precip = "precip"
        case snowfall = "snowfall"
        case snowfallkuchera = "snowfallKuchera"
        case cldcvr = "cldCvr"
        case radsolar = "radSolar"
        case radsolardirect = "radSolarDirect"
        case cin = "cin"
        case cape = "cape"
        case hailsize = "hailSize"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursTimestampStarttimestampEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of vertically interpolated quarterhourly HRRR forecast data for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter height: (path) The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, snowfall, snowfallKuchera, hailSize)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeHeightHeightQuarterhoursTimestampStarttimestampEndGet(latitude: Float, longitude: Float, timestampStart: Date, timestampEnd: Date, height: Decimal, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursTimestampStarttimestampEndGet? = nil, completion: @escaping ((_ data: HrrrForecastPointHourObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeHeightHeightQuarterhoursTimestampStarttimestampEndGetWithRequestBuilder(latitude: latitude, longitude: longitude, timestampStart: timestampStart, timestampEnd: timestampEnd, height: height, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of vertically interpolated quarterhourly HRRR forecast data for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/height/{height}/quarterhours/{timestampStart},{timestampEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "radSolar" : 0,
    "hailSize" : 0.2,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "pres" : 1013.83,
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "cin" : -100.1,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "windDir" : 302.6,
    "wetBulb" : 46.32,
    "relHum" : 96.87,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "snowfallKuchera" : 1.2,
    "radSolarDirect" : 0,
    "cape" : 2012.42,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "radSolar" : 0,
    "hailSize" : 0.2,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "pres" : 1013.83,
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "cin" : -100.1,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "windDir" : 302.6,
    "wetBulb" : 46.32,
    "relHum" : 96.87,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "snowfallKuchera" : 1.2,
    "radSolarDirect" : 0,
    "cape" : 2012.42,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "temp" : "Fahrenheit",
      "wetBulb" : "Fahrenheit",
      "dewPt" : "Fahrenheit",
      "feelsLike" : "Fahrenheit",
      "windChill" : "Fahrenheit",
      "heatIndex" : "Fahrenheit",
      "relHum" : "Percent value in [0,100]",
      "spcHum" : "Grams of Moisture per Kilograms of Air",
      "pres" : "Millibars",
      "mslPres" : "Millibars",
      "windSpd" : "Miles per Hour",
      "windDir" : "Degrees [0,360] (0 = North)",
      "precip" : "Inches",
      "snowfall" : "Inches",
      "snowfallKuchera" : "Inches",
      "cldCvr" : "Percent value in [0,100]",
      "radSolar" : "Watts per Square Meter",
      "radSolarDirect" : "Watts per Square Meter",
      "cin" : "Joules per kilogram",
      "cape" : "Joules per kilogram",
      "hailSize" : "Meters"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter height: (path) The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, snowfall, snowfallKuchera, hailSize)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<HrrrForecastPointHourObj> 
     */
    open class func pointsLatitudelongitudeHeightHeightQuarterhoursTimestampStarttimestampEndGetWithRequestBuilder(latitude: Float, longitude: Float, timestampStart: Date, timestampEnd: Date, height: Decimal, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHeightHeightQuarterhoursTimestampStarttimestampEndGet? = nil) -> RequestBuilder<HrrrForecastPointHourObj> {
        var path = "/points/{latitude},{longitude}/height/{height}/quarterhours/{timestampStart},{timestampEnd}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let timestampStartPreEscape = "\(timestampStart)"
        let timestampStartPostEscape = timestampStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampStart}", with: timestampStartPostEscape, options: .literal, range: nil)
        let timestampEndPreEscape = "\(timestampEnd)"
        let timestampEndPostEscape = timestampEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampEnd}", with: timestampEndPostEscape, options: .literal, range: nil)
        let heightPreEscape = "\(height)"
        let heightPostEscape = heightPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{height}", with: heightPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<HrrrForecastPointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
